#ifndef IMAGESOURCE_H_
#define IMAGESOURCE_H_

/*
#include <vil/vil_image_view.h>
#include <vil/vil_save.h>
#include <vil/vil_copy.h>
*/
class ImageSource
{
protected:
	/// The frame dimensions
	int image_width, image_height;
	/// Color depth
	int image_depth;
	/// RGB buffer size
	unsigned long bufSize;
	/// Is the camera active
	bool isActive;
	/// Did the last op return successfully?
	bool camResult;
	/// My pretty vil image view
	//vil_image_view<vxl_byte> image;
	/// The raw buffer
    unsigned char *buffer;

public:
	ImageSource();
	virtual ~ImageSource();
	bool IsActive() const
	{
		return isActive;
	}
	int GetHeight() const { return image_height;}
	int GetWidth() const { return image_width;}
	int GetDepth() const { return image_depth;}
    unsigned char *GetBuffer() { return buffer; }
    void ReleaseBuffer()
    {
        if (buffer)
        {
            delete buffer;
            buffer = NULL;
        }
    }
    /*
    /// Convert to a vil_image_view for further image processing
	virtual vil_image_view<vxl_byte>& GetVXLImage();
	/// Save the image/buffer to file saveFileName
	virtual void SaveImage( const char *saveFileName ); */
	/// Is the buffer null? If so, do nothing, else grab a frame.
	virtual bool HasNullBuffer() const { if (!buffer) return true; return false;}
	virtual bool InitCamera() = 0;
	virtual void ShowParams() const = 0;
	virtual bool GetFrame() = 0;
};



#endif /*IMAGESOURCE_H_*/
