#include "FirewireSource.h"
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>

// By making the objects/variable as global, they are persistent between mex calls.
// This avoids resetting the camera all the time.

bool First = true;
unsigned char *pImageBuf;
int ImageSize;
int myXsize;
int myYsize;

FirewireSource FwCamera;

unsigned char *GetFrame(int *pXsize, int *pYsize) {

	if (First) {
	    /*std::cout << "Initializing camera...\n";
		if (!FwCamera.InitCamera()) {
			std::cout << "Camera not ready\n";
			return NULL;
		}*/
		FwCamera.InitCamera();
		FwCamera.GetImageSize(&myXsize, &myYsize);
		ImageSize = myXsize * myYsize *3;
		pImageBuf = new unsigned char[ImageSize];
		First = false;
	}
	(*pXsize) = myXsize;
	(*pYsize) = myYsize;
	
	FwCamera.GetFrame();
	memcpy(pImageBuf, FwCamera.GetBuffer(),ImageSize*sizeof(unsigned char));
	
#if 0
	// This is for debug purposes, if you want to save the file	
	FILE *imagefile=fopen("test.pgm", "w");
	if( imagefile == NULL) {
		std::cout << "Had trouble saving file\n";
	} else {
		unsigned long pix;
		fprintf(imagefile,"P5\n%u %u 255\n",(*pXsize), (*pYsize));
		for (pix = 0; pix < (*pXsize) * (*pYsize)*3; pix+=3) {
			fwrite((const char *)&pImageBuf[pix], 1, 1, imagefile);
		}
		fclose(imagefile);
	}
#endif	
	return pImageBuf;
}
	
